//  gachoice
//  E:\Appl\Harbour\dbu9\
//  Anand K Gupta  Fri, 29 Jul 2016

//*****************************************************************************
func gachoice(wt_2, wl_l_rel, wt_wh,wl_43, items, lSelect, ci_func, cur_el,rel_row)
local i,cSel,lOk,n,cColor,citem

cSel := Select()
lOk := .f.
cFilt := ""
items2 := items

while .t.
	lFilt := .f.
	cColor := SetColor(color1)
	@ maxrow(),1 say "Filtered Search : "+pad(cFilt,50)
	SetColor(cColor)
	n := achoice(wt_2, wl_l_rel, wt_wh,wl_43, items, lSelect, "gi_func", cur_el,rel_row)
//Debuglog(n, lFilt)
	if lFilt
		items := {}
		for i := 1 to len(items2)
			if cFilt $ items2[i]
				aadd(items, items2[i])
	        endif
	    next
		if empty(items)
			items	:= items2
	    endif
	    KEYBOARD CHR(4)		// Home

		loop
	endif
	if n > 0
		citem := items[n]
		n := ascan(items2, citem)
	endif

	cColor := SetColor(color1)
	@ maxrow(),1
	SetColor(cColor)
	lOk := .t.
	exit
end
//Debuglog(n, lFilt, M->keystroke)

Select (cSel)

return n

//*****************************************************************************
FUNCTION gi_func

PARAMETERS amod, sel, rel
PRIVATE r, srow, scol

* multibox looks at screen coordinates..must save
srow = ROW()
scol = COL()

IF M->error_on
	* erase error message
	error_off()

ENDIF

IF M->amod = 4
	* nothing selectable
	r = 0

ELSE
	* maintain row and element variables
	cur_el = M->sel
	rel_row = M->rel

	* assume continue
	r = 2

	* get latest keystroke
	keystroke = LASTKEY()

ENDIF

IF M->cur_el > M->rel_row + 1
	* first element not on screen
	@ M->wt + 2, M->wl + 44 SAY M->more_up

ELSE
	* first element is on screen
	@ M->wt + 2, M->wl + 44 SAY " "

ENDIF

IF M->i_full - M->cur_el > M->wh - 2 - M->rel_row
	* last element not on screen
	@ M->wt + M->wh, M->wl + 44 SAY M->more_down

ELSE
	* last element is on screen
	@ M->wt + M->wh, M->wl + 44 SAY " "

ENDIF

if LASTKEY() = 8	// backspace
	if len(cFilt) > 1
		cFilt := left(cFilt, len(cFilt)-1)
    else
    	cFilt := ""
    endif
	lFilt	:= .t.
	keystroke = 219
	amod = 3
endif

IF M->amod = 3
	* keystroke exception

//Debuglog(M->keystroke)

	DO CASE

		CASE M->keystroke = 27
			* escape..abort
			r = 0

		CASE M->keystroke = 13 .OR. M->keystroke = 19 .OR. M->keystroke = 219
			* quit achoice no abort..only the enter key will cause selection
			r = 1

		CASE M->keystroke = 1
			* home key..top of list
			KEYBOARD CHR(31)	&& ^PgUp

		CASE M->keystroke = 6
			* end key..end of list
			KEYBOARD CHR(30)	&& ^PgDn

		CASE isdata(M->keystroke)
			* request character search
			r = 1	//3
			cFilt += upper(chr(M->keystroke))
			lFilt := .t.

		CASE menu_key() <> 0
			* abort to menu system
			r = 0

	ENDCASE
ENDIF

* restore screen coordinate
@ M->srow, M->scol SAY ""

RETURN M->r

